(***********************************************************************)
(*                                                                     *)
(*                              OCamlGen                               *)
(*                                                                     *)
(*                       OCaml module Generator                        *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 1997-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: lib_print_xml.mli,v 1.13 2014/01/31 09:51:52 fclement Exp $ *)

(** Runtime library for xml pretty-printers generated with OCamlGen. *)

open Format_printer;;

val print_xml_unit : unit Format_printer.printer;;
val print_xml_bool : bool printer;;
val print_xml_quoted_string : string printer;;
val print_xml_quoted_char : char printer;;
val print_xml_quoted_int : int printer;;
val print_xml_quoted_nativeint : nativeint printer;;
val print_xml_quoted_int32 : int32 printer;;
val print_xml_quoted_int64 : int64 printer;;
val print_xml_quoted_float : float printer;;

val print_xml_Couple : ('a, 'b, ('a * 'b)) printer_lifter2;;
val print_xml_Triple : ('a, 'b, 'c, ('a * 'b * 'c)) printer_lifter3;;
val print_xml_List : ('a, 'a list) printer_lifter;;
val print_xml_Array : ('a, 'a array) printer_lifter;;
val print_xml_Option : ('a, 'a option) printer_lifter;;
val print_xml_Ref : ('a, 'a ref) printer_lifter;;

val print_xml_fun : ('a, 'b, ('a -> 'b)) printer_lifter2;;

val print_xml_poly : 'a printer;;
val print_xml_abstract : 'a printer;;
val print_xml_external : 'a printer;;

val print_xml_couple :
  (unit, Format.formatter, unit) format ->
  ('a, 'b, ('a * 'b)) printer_lifter2
;;
val print_xml_triple :
  (unit, Format.formatter, unit) format ->
  ('a, 'b, 'c, ('a * 'b * 'c)) printer_lifter3
;;
val print_xml_list :
  (unit, Format.formatter, unit) format ->
  ('a, 'a list) printer_lifter
;;
val print_xml_array :
  (unit, Format.formatter, unit) format ->
  ('a, 'a array) printer_lifter
;;
val print_xml_option :
  (unit, Format.formatter, unit) format ->
  ('a, 'a option) printer_lifter
;;
val print_xml_ref :
  (unit, Format.formatter, unit) format ->
  ('a, 'a ref) printer_lifter
;;
