(* $Id: camlmeta.ml,v 1.3 2012/05/22 15:11:17 fclement Exp $ *)

open Walk_ast_gen;;
open Do_walk;;

module Io : Do_walk.Output =
 struct
  let pp = Format.std_formatter;;
 end;;

module Meta_Treat
       (P : Walk_ast_gen.Prefix)
       (Gen : Gen_walker)
       (Out : Do_walker)
       (Io : Do_walk.Output) =
  struct

   (* Obtention du module qui fabrique l'arbre de syntaxe abstraite du walker *)
   module Make_walk = Walk_ast_gen.Make_walk_ast_generator (P);;

   module Output =
     functor (Io : Output) -> Do_walk.Make (Io) (Gen) (Out);;
   (* Obtention du module gnrateur d'imprimeurs *)
   module Walker = Output (Io);;

   let file ast =
     (* On imprime la dfinition de types. *)
     Types.file Io.pp ast;
     let walk_ast = Make_walk.file ast in
     Walker.file walk_ast;;

end
;;

module Meta_Main (P : Prefix) (Gen : Gen_walker) (Out : Do_walker) =
 struct
   module Treat = Meta_Treat (P) (Gen) (Out);;
   module Main = Walk_file.Main (Io) (Treat);;
   let main = Main.main;;
end
;;

module Main (P : Prefix) (Out : Do_walker) = Meta_Main (P) (Walk_gen.Gen);;
